package 
{
	import flash.display.Graphics;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.events.Event;
	import soundBoard.Soundboard;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	
	/**
	 * ...
	 * @author JeremyMarkowitz
	 * 
	 * The Main class is the only class that sits outside the Soundboard package.  It sets the stage at 800x600.  It also adds
	 * a resize listener.  Once the stage is instantiated, Main creates a Soundboard object, places it on the stage, and masks it at 800x600 so off-stage
	 * content will not be seen.
	 * 
	 * The Soundboard object is created with a path to the xml file, which must be named 'soundboard.xml' and reside in the same location
	 * as the .swf
	 * 
	 * soundboard.xml allows customization of some components, including button colors, background image, paths to all the mp3s,
	 * and what each sound button will read.
	 * 
	 * Text colors of buttons can be configured in AppCSS.css
	 * 
	 **/
	public class Main extends Sprite 
	{
		[SWF( width = "800", height = "400" )]
		public function Main():void 
		
		
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		public static const APP_WIDTH:uint = 800;
		public static const APP_HEIGHT:uint = 600;
		private var soundboard:Soundboard;
		
		private function init(e:Event = null):void 
		{
			soundboard = new Soundboard("soundboard.xml");
			//soundboard.width = APP_WIDTH;
			//soundboard.height = APP_HEIGHT;
			trace("soundboard.width, height  ", soundboard.width, soundboard.height);
			trace("stage.width, height  ", stage.width, stage.height);
			soundboard.x = 0;
			soundboard.y = 0;
			
			stage.addEventListener(Event.RESIZE, resizeHandler);
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.dispatchEvent(new Event(Event.RESIZE));


			var mask:Sprite = new Sprite();
			
			var gr:Graphics = mask.graphics;
			gr.beginFill(0x000000);
			gr.drawRect(0, 0, APP_WIDTH, APP_HEIGHT);
			gr.endFill();
			
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point

			addChild(soundboard);
			soundboard.mask =  mask;
		}
		
		private function resizeHandler(e:Event):void {

			soundboard.x = 0;
			soundboard.y = 0;
		}
		
	}
	
}