﻿package soundBoard {
	import flash.accessibility.AccessibilityProperties;
	import flash.display.Shape;
	import flash.display.SimpleButton;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.filters.DropShadowFilter;
	import flash.filters.GlowFilter;
	import flash.text.TextFormat;
	import flash.text.TextField;
	import flash.media.Sound;

	//import flash.text.StyleSheet;

	public class CustomSoundButton extends Sprite {
		private var _sound:Sound;

		public var button:CustomSimpleButton;
		private var label:TextField;
		private var labelBtm:TextField;
		private var description:String;
		private var _name:String;
		private var _id:uint;
		private var _soundPath:String;

		private var _width:uint;
		private var _height:uint;
		private var _upColor:uint = 0x1FB24B;
		private var _overColor:uint = 0x423B39;
		private var _downColor:uint = 0x750D21;
		private var model:IModel;

		public function CustomSoundButton(_model:IModel, text:String, soundPath:String) {
			this.model = _model;
			this._soundPath = soundPath;
			
			if (text.length > 25){
				this._height = model.bH;
			} else {
				this._height = model.bH;
			}
			// if w or h is 0 then make w or h the constant, otherwise keep it the w or h
			this._width = model.bW;

			this._upColor = model.bUp;
			this._overColor = model.bOver;
			this._downColor = model.bDown;

			button = buildButton();
			addChild(button);
			addChild(button.swapState);// rectangle to show when grabbed
			button.alpha = .45;
			label = buildLabel(0xFFFFFF);
			addChild(label);
			setLabel(text);

		}


		private function buildButton():CustomSimpleButton {
			var btn:CustomSimpleButton = new CustomSimpleButton(_width, _height, _upColor, _overColor, _downColor);

			return btn;
		}

		private function buildLabel(txtColor:uint):TextField {
			var format:TextFormat = new TextFormat;
			format.font = "Verdana";
			format.size = 11;
			format.color = txtColor;
			//format.align=TextFormatAlign.CENTER;
			format.bold = true;

			var lbl:TextField = new TextField;
			lbl.y = 1;
			lbl.width = _width;
			lbl.height = _height;
			lbl.selectable = false;
			lbl.defaultTextFormat = format;
			lbl.mouseEnabled = false;
			lbl.wordWrap = true;
			//lbl.filters = [new DropShadowFilter(1.2, 45, 0, 1, 1.5, 1.5, .8, 1)];
			lbl.filters = [new GlowFilter(0x000000, .8, 4, 4, 1.8)];

			return lbl;
		}

		public function setSwapState(trueState:Boolean):void {
			if (trueState) {
				button.swapStateOn();
				
			} else {
				button.swapStateOff();
			}

		}

		public function setLabel(text:String):void {
			label.text = text;
			this._name = text;
		}

		public function getLabel():String {
			return label.text;
		}

		public function setDescription(text:String):void {
			description = text;
		}

		public function get sound():Sound {
			return _sound;
		}

		public function set sound(value:Sound):void {
			_sound = value;
		}

		public function get id():uint {
			return _id;
		}

		public function set id(value:uint):void {
			_id = value;
		}
		
		public function get soundPath():String 
		{
			return _soundPath;
		}

	}

}