﻿package soundBoard{
	import flash.display.Sprite;
	import flash.display.Graphics;
	import flash.events.MouseEvent;
	import flash.display.Shape;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;
	public class RoundBtn extends Sprite {

		private static const BTN_OFF_FILL:uint=0xEAEAEA;
		private static const BTN_OFF_LINE:uint=0x3C3C3C;
		private static const BTN_OVR_FILL:uint=0xFCFCFC;
		private static const BTN_OVR_LINE:uint=0x000000;
		private static const BTN_DOWN_FILL:uint=0xB3B3B3;
		private static const BTN_DOWN_LINE:uint = 0x696969;
		
		private static const TEXT_COLOR:uint = 0x000000;

		public var hit:Sprite;// this is the hit area
		public var sHit:Shape;
		public var sOff:Shape;
		public var sOver:Shape;
		public var sDown:Shape;
		public var tf:TextField;
		public var sLabel:String;

		public var hitW:uint;
		public var hitH:uint;

		protected var offFillColor:uint;
		protected var overFillColor:uint;
		protected var downFillColor:uint;
		protected var offLineColor:uint;
		protected var overLineColor:uint;
		protected var downLineColor:uint;
		protected var txt:TextField;
		protected var txtSize:uint;
		protected var textColor:uint;
		protected var hardW:uint;
		protected var hardH:uint;
		protected var _buttonActive:Boolean = true;

		public function RoundBtn(str:String, txtSize:uint = 10 , hardW:uint=0, hardH:uint= 0  ) {

			this.sLabel=str;
			this.txtSize=txtSize;
			
			this.hardW = hardW;
			this.hardH = hardH;

			getColors();
			drawTextBox();
			drawGraphics();
			placeChildren();
			addEventHandlers();
			setActive(true);
		}

		protected function getColors() :void{
			offFillColor=BTN_OFF_FILL;
			offLineColor=BTN_OFF_LINE;

			overFillColor=BTN_OVR_FILL;
			overLineColor=BTN_OVR_LINE;

			downFillColor=BTN_DOWN_FILL;
			downLineColor = BTN_DOWN_LINE;
			
			textColor = TEXT_COLOR;

		}

//		private function initStyle():void {
//
//			css= new StyleSheet();
//			buttonStyle= new Object();
//			buttonStyle.color="#000000";
//			buttonStyle.fontFamily="Arial";
//			buttonStyle.fontSize=12;
//			buttonStyle.fontWeight="bold";
//			css.setStyle(".button", buttonStyle);
//		}

		public function drawTextBox() :void{
			tf=makeTextField(sLabel);
			if(hardW>0){
				hitW = hardW;
			} else{
				 hitW= tf.width+(txtSize/2);
			}
			if(hardH>0){
				hitH = hardH;
			} else{
				hitH = tf.height+(txtSize/2);
			}
		}
		
		public function drawGraphics():void{

			sOff=doButtonShape(offLineColor,offFillColor,hitW,hitH);
			sOver=doButtonShape(overLineColor,overFillColor,hitW,hitH);
			sOver.alpha=0;
			sDown=doButtonShape(downLineColor,downFillColor,hitW,hitH);
			sDown.alpha=0;
			sHit=doButtonShape(0x0066FF,0xFF0000,hitW,hitH);
			sHit.alpha=0;
			hit= new Sprite();
			hit.buttonMode=true;
			hit.addChild(sHit);
		}
		
		public function placeChildren():void {
			this.addChild(sOver);
			this.addChild(sDown);
			this.addChild(sOff);
			swapChildren(tf, sOff);
			this.addChild(hit);
			
			//reposition tf
			tf.x= hit.x + ((hit.width - tf.width) * .48);
			tf.y= hit.y + ((hit.height- tf.height) * .38 );	
		}

		public function doButtonShape(lineColor:uint, fillColor:uint, w:uint, h:uint):Shape {
			var child:Shape = new Shape();
			child.graphics.beginFill(fillColor);
			//child.graphics.lineStyle(1, lineColor, 1,true);
			child.graphics.drawRoundRect(0,0,w,h,6);
			child.graphics.endFill();
			return child;
		}
		

		private function makeTextField(str:String):TextField {

			txt=new TextField();
			addChild(txt);
			setText(str);
			txt.selectable=true;
			txt.autoSize=TextFieldAutoSize.CENTER;
			txt.background = false;
	
			var txtFmt:TextFormat =  new TextFormat();
			txtFmt.font = "Verdana";
			txtFmt.size =txtSize;
			txtFmt.bold = true;
			txtFmt.color = textColor;
			//txtFmt.letterSpacing = 1;
			txt.defaultTextFormat=txtFmt;
			txt.setTextFormat(txtFmt);	
			
			return txt;
		}

		public function setText(labelStr:String) :void{
			txt.text =labelStr;
		}
		
		public function getText():String {
			return txt.text;
		}

		public function addEventHandlers() :void{
			hit.addEventListener(MouseEvent.MOUSE_OVER, overH );
			hit.addEventListener(MouseEvent.MOUSE_OUT, outH );
			hit.addEventListener(MouseEvent.MOUSE_DOWN, downH);
			hit.addEventListener(MouseEvent.MOUSE_UP, upH );
		}

		public function overH(e:MouseEvent = null) :void {
			if(_buttonActive){sOver.alpha=1;}

		}

		public function outH(e:MouseEvent = null) :void {
			if(_buttonActive){sOver.alpha=0;}
		}

		public function downH(e:MouseEvent = null):void {
			if(_buttonActive){sDown.alpha=1;}
			
		}

		public function upH(e:MouseEvent = null) :void {
			if(_buttonActive){sDown.alpha=0;}
		}
		
		public function setActive(b:Boolean):void {
			_buttonActive = b;
			if (_buttonActive) {
				this.buttonMode = true;
				sDown.alpha=0;
			} else {
				buttonMode = false;
				this.sDown.alpha=1;
				
			}
		}

	}
}