package soundBoard 
{
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.media.Sound;
	/**
	 * ...
	 * @author JM
	 */
	public class SoundboardModel extends EventDispatcher implements IModel 
	{
		public static const FEVER:String = "feverDreamingUpdate";
		public static const SWAP:String = "swappingUpdate";
		public static const GHOST:String = "newGhostButton";
		public static const GHOST_NULL:String = "removeGhostButton";
		public static const PLAY_SELECTED_SOUND:String = "playSelectedSound";
		public static const CUSTOM_ADD:String = "addButtonToCustomPage";
		public static const CUSTOM_DELETE:String = "deleteButtonFromCustomPage";
		public static const SOUNDS_CHANGE:String = "changeToSoundArray";
		
		private var _stage:Stage;
		private var idCounter:uint = 0;
		
		private var _pageMaxCols:uint = 4;
		
		private var _bgImg:Bitmap;
		private var _bgFeverImg:Bitmap;
		private var _btnActionState:SoundboardButtonState;
		private var _soundChannelState:SoundboardSoundState;
		private var _bitmapState:BitmapState;
		private var _selectingButton:CustomSoundButton;
		private var _selectedSound:Sound;
		//private var _feverDreaming:Boolean;
		private var _ghostBtn:CustomSoundButton;
		private var _swapToSelection:CustomSoundButton; // button the selecting button will swap positions with
		
		// App data
		private var _dataXML:XML;
		private var _bW:uint;
		private var _bH:uint;
		private var _bUp:uint;
		private var _bOver:uint;
		private var _bDown:uint;
		private var _gutter:uint = 5;
		private var _maxRow:uint = 25; // rewritten in app data
		private var _appTitleText:String =" ";

		private var _allSounds:Array = [];
		private var _aSounds:Array = [];
		private var _aPgBtns:Array = [];
		private var _aPages:Array = [];
		private var _currPage:uint = 1;

		
		public function SoundboardModel(stg:Stage) 
		{
			this._stage = stg;
		}
		
		public function get btnActionState():SoundboardButtonState 
		{
			return _btnActionState;
		}
		
		public function set btnActionState(state:SoundboardButtonState):void 
		{
			_btnActionState = state;
		}
		
		public function get selectingButton():CustomSoundButton 
		{
			return _selectingButton;
		}
		
		public function set selectingButton(button:CustomSoundButton):void 
		{
			_selectingButton = button;
		}
		
		//public function get feverDreaming():Boolean 
		//{
			//return _feverDreaming;
		//}
		
		//public function set feverDreaming(bool:Boolean):void 
		//{
			//_feverDreaming = bool;
			//feverDreamUpdate();
		//}
		
		public function get ghostBtn():CustomSoundButton 
		{
			//trace("model.ghostBtn : get ghostBtn =" + _ghostBtn, (_ghostBtn.parent));
			return _ghostBtn;
		}
		
		public function set ghostBtn(btn:CustomSoundButton):void 
		{		
				_ghostBtn = btn;
				//if (!btn) {
					//trace("Sbmodel:!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! ghostbutton null");
				//}
				//trace("model.ghostBtn  set ghostBtn: =" + _ghostBtn, (_ghostBtn.parent));
		}
		
		public function get swapToSelection():CustomSoundButton 
		{
			return _swapToSelection;
		}
		
		public function set swapToSelection(btn:CustomSoundButton):void 
		{
			this.btnActionState = new SbStSwappingButtons(this);
			_swapToSelection = btn;
		}
		
		public function get dataXML():XML 
		{
			return _dataXML;
		}
		
		public function set dataXML(value:XML):void 
		{
			_dataXML = value;
			
			_bW = _dataXML.appData.buttonDims.@width;
			_bH = _dataXML.appData.buttonDims.@height;
			_gutter = _dataXML.appData.buttonDims.@gutter;
			_maxRow = _dataXML.appData.buttonDims.@maxRows;

			_bUp = _dataXML.appData.buttonColors.@up;
			_bOver = _dataXML.appData.buttonColors.@over;
			_bDown = _dataXML.appData.buttonColors.@down;
			
			(_dataXML.appData.title.@text == "" ) ? _appTitleText = " " : _appTitleText =_dataXML.appData.title.@text;
			
		}
		
		public function get bW():uint 
		{
			return _bW;
		}
		
		//public function set bW(value:uint):void 
		//{
			//_bW = value;
		//}
		
		public function get bH():uint 
		{
			return _bH;
		}
		
		//public function set bH(value:uint):void 
		//{
			//_bH = value;
		//}
		
		public function get bUp():uint 
		{
			return _bUp;
		}
		
		//public function set bUp(value:uint):void 
		//{
			//_bUp = value;
		//}
		
		public function get bOver():uint 
		{
			return _bOver;
		}
		
		//public function set bOver(value:uint):void 
		//{
			//_bOver = value;
		//}
		
		public function get bDown():uint 
		{
			return _bDown;
		}
		
		//public function set bDown(value:uint):void 
		//{
			//_bDown = value;
		//}
		
		public function get gutter():uint 
		{
			return _gutter;
		}
		
		//public function set gutter(value:uint):void 
		//{
			//_gutter = value;
		//}
		
		public function get maxRow():uint 
		{
			return _maxRow;
		}
		
		//public function set maxRow(value:uint):void 
		//{
			//_maxRow = value;
		//}
		
		public function get allSounds():Array 
		{
			return _allSounds;
		}
		
		public function set allSounds(value:Array):void 
		{
			_allSounds = value;
		}
		
		public function addSoundboardSound(soundBtn:CustomSoundButton):uint {
			idCounter++;
			_aSounds.push({id:idCounter, button:soundBtn});
			aSoundsUpdate();
			return(idCounter);
		}
		public function getAddedSound():CustomSoundButton {
			return _aSounds[_aSounds.length-1].button;
		}

		
		public function get currPage():uint 
		{
			return _currPage;
		}
		
		public function set currPage(pgNum:uint):void 
		{
			_aPgBtns[_currPage - 1].setActive(true);
			_aPgBtns[pgNum - 1].setActive(false);
			_currPage = pgNum;
		}
		
		public function get aPgBtns():Array 
		{
			return _aPgBtns;
		}
		
		public function set aPgBtns(btns:Array):void 
		{
			_aPgBtns = btns;
		}
		
		public function get aPages():Array 
		{
			return _aPages;
		}
		
		public function set aPages(pages:Array):void 
		{
			_aPages = pages;
		}
		
		public function get pageMaxCols():uint 
		{
			return _pageMaxCols;
		}
		
		public function set pageMaxCols(value:uint):void 
		{
			_pageMaxCols = value;
		}
		
		public function get stage():Stage 
		{
			return _stage;
		}
		
		public function get soundChannelState():SoundboardSoundState 
		{
			return _soundChannelState;
		}
		
		public function set soundChannelState(soundState:SoundboardSoundState):void 
		{
			_soundChannelState = soundState;
		}
		
		public function get selectedSound():Sound 
		{
			return _selectedSound;
		}
		
		public function set selectedSound(sound:Sound):void 
		{
			_selectedSound = sound;
		}
		
		public function get appTitleText():String
		{
			return _appTitleText;
		}
		
		public function get bgImg():Bitmap
		{
			return _bgImg;
		}
		
		public function set bgImg(value:Bitmap):void 
		{
			_bgImg = value;
		}
		
		public function get bitmapState():BitmapState 
		{
			return _bitmapState;
		}
		
		public function set bitmapState(value:BitmapState):void 
		{
			_bitmapState = value;
		}
		
		public function get bgFeverImg():Bitmap 
		{
			return _bgFeverImg;
		}
		
		public function set bgFeverImg(value:Bitmap):void 
		{
			_bgFeverImg = value;
		}
				
		public function playSelectedSound():void {
			dispatchEvent(new Event(SoundboardModel.PLAY_SELECTED_SOUND));
		}
		
		public function customPageAddButton():void {
			customButtonAddUpdate();
		}
		public function customPageDeleteButton():void {
			customButtonDeleteUpdate();
		}
		public function swapButtons():void {
			_aPages[_currPage-1].swapInButtonsArray(selectingButton, swapToSelection );
			
			var selectToX:Number = swapToSelection.x;
			var selectToY:Number = swapToSelection.y;
			swapToSelection.x = selectingButton.x;
			swapToSelection.y = selectingButton.y;
			selectingButton.x = selectToX;
			selectingButton.y = selectToY;
			
			selectingButton.setSwapState(false);
			swapToSelection.setSwapState(false);
			swapUpdate();
		}
		
		public function removeGhostBtn():void {
			dispatchEvent(new Event(SoundboardModel.GHOST_NULL));
		}		

		protected function swapUpdate():void {
			dispatchEvent(new Event(SoundboardModel.SWAP));
		}		

		protected function customButtonAddUpdate():void {
			dispatchEvent(new Event(SoundboardModel.CUSTOM_ADD));
		}
		protected function customButtonDeleteUpdate():void {
			dispatchEvent(new Event(SoundboardModel.CUSTOM_DELETE));
		}	
		
		protected function aSoundsUpdate():void 
		{
			dispatchEvent(new Event(SoundboardModel.SOUNDS_CHANGE));
		}

	}

}