package soundBoard 
{
	import flash.display.Sprite;
	import soundBoard.CustomSoundButton;
	/**
	 * ...
	 * @author JM
	 */

	public class SoundsPage extends Sprite
	{

		private var _aPageSounds:Array = [];
		private var _pgNumber:uint;
		protected var model:IModel;
		
		private var writeCol:uint = 0;
		private var writeRow:uint = 0;
		private var xCurs:Number = 0;
		private var yCurs:Number = 0;
		
		public function SoundsPage(_model:IModel) {
			this.model = _model;
		}
	
		public function get aPageSounds():Array 
		{
			return _aPageSounds;
		}
		
		public function get id():uint 
		{
			return _pgNumber;
		}
		
		public function set pgNumber(value:uint):void 
		{
			_pgNumber = value;
		}
		
		public function addSound(soundBtn:CustomSoundButton):Boolean 
		{
			var success:Boolean = true;
			if (writeRow < model.maxRow ) {
				//write to row
				addButton(soundBtn);
				writeRow++;
			} else {
				//newCol
				writeCol++	
				if (writeCol < model.pageMaxCols) {
					//write to Col
					writeRow = 0;
					addButton(soundBtn);
					writeRow++;
				} else {
					//page is full!
					success = false;
				}
			}	
			//trace("SPage: ADD  _aPageSounds.length = " + _aPageSounds.length +"\n WriteRow="+writeRow+" WriteCol="+writeCol);
			return success;
		}
		
		private function addButton(soundBtn:CustomSoundButton):void 
		{
			
			soundBtn.x = writeCol * (model.bW + model.gutter);
			soundBtn.y = writeRow * (model.bH +1);
			addChild(soundBtn);
			_aPageSounds.push(soundBtn);
			// initializes sound
			soundBtn.id = model.addSoundboardSound(soundBtn);		
		}
		
		public function removeSound(sb:CustomSoundButton):void 
		{
			moveButtons(sb);
			this.removeChild(sb);
			//remove from array
			for (var i:int = 0; i < _aPageSounds.length; i++) 
			{
				if (_aPageSounds[i].id == sb.id) {
					_aPageSounds.splice(i, 1);
				}
				if (_aPageSounds.length < 1) {
					writeCol = writeRow = 0;
				}
				trace("SPage: REMOVE _aPageSounds.length = " + _aPageSounds.length +"\n WriteRow="+writeRow+" WriteCol="+writeCol);
				
				
			}

		}		
		private function moveButtons(delBtn:CustomSoundButton):void {

			var lastBtn:CustomSoundButton = _aPageSounds[0];
			for each(var btn:CustomSoundButton in _aPageSounds) {
				if (btn.x > delBtn.x ) {
					if (btn.y == 0) {
						// move to bottom of column one to left
						btn.x -= btn.y + (model.bW + model.gutter);
						btn.y = (model.maxRow -1)*(model.bH +1);
					} else {
						// move button in next column up in same column
						btn.y -= (model.bH +1);
					}
				} else if ((btn.x == delBtn.x) && btn.y > delBtn.y ) {
						//same row as del button, but move up
						btn.y = btn.y - (btn.height );
						
				}
				if (btn.x > lastBtn.x || btn.x == lastBtn.x && btn.y > lastBtn.y) {
					if(btn!=delBtn){
						lastBtn =  btn;
					}
				}
			}


			writeRow = lastBtn.y / model.bH +1;
			writeCol = lastBtn.x /  (model.bW + model.gutter);
		}
		
		public function swapInButtonsArray(swapFrom:CustomSoundButton, swapTo:CustomSoundButton):void {
			
			var fromIndex:uint = _aPageSounds.lastIndexOf(swapFrom);
			var toIndex:uint = _aPageSounds.lastIndexOf(swapTo);
			_aPageSounds[fromIndex] = swapTo;
			_aPageSounds[toIndex] = swapFrom;
			//trace("SoundsPage: updating swap of " + swapFrom.getLabel() +" and " + swapTo.getLabel());

		}
		
	}

}