package soundBoard {
	
	import flash.display.BitmapData;
	import flash.display.Loader;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.text.StyleSheet;
	import flash.events.IOErrorEvent;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import soundBoard.IModel;
	
	public class XmlLoader extends EventDispatcher{
		
		public static var XML_LOADED:String = "xml_loaded";
		
		private var loader:URLLoader = new URLLoader();
		private var imgLoader:Loader;
		private var _appXML:XML;
		private var styleS:StyleSheet = new StyleSheet();
		private var bgImg:BitmapData;
		private var _appVars:XMLList;

		//private var _xmlPath:String;

		
		public function XmlLoader() {
		}
		
		public function loadXML(_xmlPath:String):void{
			// preloader?
			loader.addEventListener(IOErrorEvent.IO_ERROR, errorHandler);
			loader.addEventListener(Event.COMPLETE, loaderComplete);
			loader.load(new URLRequest(_xmlPath));
		}
		
		private function loaderComplete(e:Event):void{
			e.target.removeEventListener(Event.COMPLETE, loaderComplete);
			e.target.removeEventListener(Event.COMPLETE, errorHandler)
			_appXML=new XML(e.target.data);
			loadCSS();
		}
		
		private function loadCSS():void {

            loader.addEventListener(IOErrorEvent.IO_ERROR, errorHandler);
            loader.addEventListener(Event.COMPLETE, cssLdrComplete);
			loader.load(new URLRequest(_appXML.appData.css.@path));
		}
		
		private function cssLdrComplete(e:Event):void{
			e.target.removeEventListener(Event.COMPLETE, cssLdrComplete);
			e.target.removeEventListener(Event.COMPLETE, errorHandler)
			styleS.parseCSS(loader.data);
			loadBackgroundImg();
		}		
		
		private function loadBackgroundImg():void {
			imgLoader = new Loader();
			imgLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, errorHandler);
            imgLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, bgImgLdrComplete);
			imgLoader.load(new URLRequest(_appXML.appData.bgImg.@path));
						
		}
		
		private function bgImgLdrComplete(e:Event):void{
			e.target.removeEventListener(Event.COMPLETE, bgImgLdrComplete);
			e.target.removeEventListener(Event.COMPLETE, errorHandler)
			trace(imgLoader);
			dispatchComplete();
		}		

		private function errorHandler(e:IOErrorEvent):void {
            trace ("XMLLoader: !!! ERROR: Couldn't load XML.")
			trace (e);
        }
        private function dispatchComplete():void {

			this.dispatchEvent(new Event(XmlLoader.XML_LOADED));
		}
		
		public function getAppXML():XML{
			return _appXML;
		}
		
		public function getBackgroundImg():Loader{
			return imgLoader;
		}
	}
}